## molequeue 0.9.0

=== docs/CMakeLists.txt ===
find_package(Doxygen REQUIRED)

set(doxygen_source_dirs
  "${MoleQueue_SOURCE_DIR}/molequeue ${MoleQueue_SOURCE_DIR}/docs")
set(doxygen_output_dir "${CMAKE_CURRENT_BINARY_DIR}")

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/doxyfile.in"
  "${CMAKE_CURRENT_BINARY_DIR}/doxyfile")

add_custom_target(documentation
  COMMAND ${CMAKE_COMMAND} -E remove_directory ${CMAKE_CURRENT_BINARY_DIR}/html
  COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/doxyfile)

=== molequeue/CMakeLists.txt ===
option(MoleQueue_BUILD_APPLICATION "Build the MoleQueue server application" ON)
option(MoleQueue_BUILD_CLIENT "Build the MoleQueue client library" ON)
option(USE_ZERO_MQ "Build molequeue with ZeroMQ support" OFF)

add_subdirectory(servercore)
include_directories(${CMAKE_CURRENT_BINARY_DIR}/servercore)

# Are we using ZeroMQ
if(USE_ZERO_MQ)
  add_subdirectory(zeromq)
  include_directories(${CMAKE_CURRENT_BINARY_DIR}/zeromq)
endif()

add_subdirectory(plugins)

# Client library
if(MoleQueue_BUILD_CLIENT)
  add_subdirectory(client)
  include_directories(${CMAKE_CURRENT_BINARY_DIR}/client)
endif()

if(MoleQueue_BUILD_APPLICATION)
  add_subdirectory(app)
endif()

# Keep "add_subdirectory(lastinstall)" last: fixup_bundle needs to be
# *after* all other install(TARGETS and install(FILES calls
if(MoleQueue_BUILD_APPLICATION)
  add_subdirectory(lastinstall)
endif()

=== python/CMakeLists.txt ===
find_package(PythonInterp REQUIRED)

if(PYTHONINTERP_FOUND)
  execute_process(COMMAND ${PYTHON_EXECUTABLE} -c
    "from distutils.sysconfig import get_python_lib; print(get_python_lib())"
    OUTPUT_VARIABLE PYTHON_PACKAGES_DIR
    OUTPUT_STRIP_TRAILING_WHITESPACE)

  install(FILES
    molequeue/__init__.py
    molequeue/client.py
    molequeue/utils.py
    DESTINATION "${PYTHON_PACKAGES_DIR}/molequeue")
endif()

=== molequeue/app/CMakeLists.txt ===
set(qt_components Core Widgets Network)

if(MoleQueue_USE_EZHPC_UIT)
  list(APPEND qt_components XmlPatterns)
endif()

find_package(Qt5 COMPONENTS ${qt_components} REQUIRED)

# Provide some simple API to find the plugins, scripts, etc.
if(APPLE)
  # It is a special case, the app bundle logic breaks the relative pathing.
  set(MoleQueue_LIB_DIR "lib")
else()
  set(MoleQueue_LIB_DIR "${INSTALL_LIBRARY_DIR}")
endif()

# Find a python 2.x interpreter.
find_package(PythonInterp 2 QUIET)

include(GenerateExportHeader)

include_directories(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR})

# multi configuration build? Needed for plugin search path
if(CMAKE_CONFIGURATION_TYPES)
  add_definitions(-DMULTI_CONFIG_BUILD)
endif()

if(CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64" AND NOT WIN32)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
endif()

set(mq_srcs
  aboutdialog.cpp
  abstractqueuesettingswidget.cpp
  advancedfilterdialog.cpp
  actionfactorymanager.cpp
  addqueuedialog.cpp
  filebrowsewidget.cpp
  filespecification.cpp
  filesystemtools.cpp
  importprogramdialog.cpp
  importqueuedialog.cpp
  job.cpp
  jobactionfactory.cpp
  jobactionfactories/killjobactionfactory.cpp
  jobactionfactories/opendirectoryactionfactory.cpp
  jobactionfactories/openwithactionfactory.cpp
  jobactionfactories/removejobactionfactory.cpp
  jobactionfactories/viewjoblogactionfactory.cpp
  jobdata.cpp
  jobitemmodel.cpp
  jobmanager.cpp
  jobreferencebase.cpp
  jobtableproxymodel.cpp
  jobtablewidget.cpp
  jobview.cpp
  localqueuewidget.cpp
  logentry.cpp
  logger.cpp
  logwindow.cpp
  mainwindow.cpp
  openwithmanagerdialog.cpp
  openwithexecutablemodel.cpp
  openwithpatternmodel.cpp
  opensshcommand.cpp
  patterntypedelegate.cpp
  pluginmanager.cpp
  program.cpp
  programconfiguredialog.cpp
  queue.cpp
  queuemanager.cpp
  queuemanagerdialog.cpp
  queuemanageritemmodel.cpp
  queueprogramitemmodel.cpp
  queues/local.cpp
  queues/pbs.cpp
  queues/remote.cpp
  queues/remotessh.cpp
  queues/sge.cpp
  queues/slurm.cpp
  queuesettingsdialog.cpp
  remotequeuewidget.cpp
  server.cpp
  sshcommand.cpp
  sshcommandfactory.cpp
  sshconnection.cpp
  templatekeyworddialog.cpp
  terminalprocess.cpp)

set(ui_files
  ui/aboutdialog.ui
  ui/addqueuedialog.ui
  ui/advancedfilterdialog.ui
  ui/importprogramdialog.ui
  ui/importqueuedialog.ui
  ui/jobtablewidget.ui
  ui/localqueuewidget.ui
  ui/logwindow.ui
  ui/mainwindow.ui
  ui/openwithmanagerdialog.ui
  ui/programconfiguredialog.ui
  ui/queuemanagerdialog.ui
  ui/queuesettingsdialog.ui
  ui/remotequeuewidget.ui
  ui/templatekeyworddialog.ui)

if(MoleQueue_USE_EZHPC_UIT)

  find_package(KDSoap REQUIRED)
  include_directories(${KDSoap_INCLUDE_DIRS})
  kdsoap_generate_wsdl(ezHPC_UIT_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/wsdl/uitapi.wsdl)

  list(APPEND mq_srcs
    ${ezHPC_UIT_SRCS}
    credentialsdialog.cpp
    queues/uit/authenticatecont.cpp
    queues/uit/authenticateresponse.cpp
    queues/uit/authresponseprocessor.cpp
    queues/uit/compositeiodevice.cpp
    queues/uit/dirlistinginfo.cpp
    queues/uit/fileinfo.cpp
    queues/uit/filestreamingdata.cpp
    queues/uit/jobevent.cpp
    queues/uit/jobeventlist.cpp
    queues/uit/jobsubmissioninfo.cpp
    queues/uit/kerberoscredentials.cpp
    queues/uit/messagehandler.cpp
    queues/queueuit.cpp
    queues/uit/sslsetup.cpp
    queues/uit/authenticator.cpp
    queues/uit/directoryupload.cpp
    queues/uit/directorycreate.cpp
    queues/uit/directorydelete.cpp
    queues/uit/directorydownload.cpp
    queues/uit/filesystemoperation.cpp
    queues/uit/requests.cpp
    queues/uit/session.cpp
    queues/uit/sessionmanager.cpp
    queues/uit/userhostassoc.cpp
    queues/uit/userhostassoclist.cpp
    uitqueuewidget.cpp
    wsdl_uitapi.cpp)

  list(APPEND ui_files
    ui/uitqueuewidget.ui
    ui/credentialsdialog.ui)

  # Disable warnings for KDSoap generate file for most platforms
  silence_warnings(wsdl_uitapi.cpp)

  # install the SSL certificates
  install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/certs
    DESTINATION ${INSTALL_DATA_DIR}/molequeue)

  # copy to build tree so things will work when running from build tree
  file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/certs
    DESTINATION  ${CMAKE_BINARY_DIR}/${INSTALL_DATA_DIR}/molequeue)

  set(MoleQueue_SSL_CERT_DIR "${INSTALL_DATA_DIR}/molequeue/certs")
endif()

if(WIN32)
  list(APPEND mq_srcs puttycommand.cpp)
endif()

qt5_wrap_ui(ui_srcs ${ui_files})

qt5_add_resources(rcc_srcs queuetray.qrc)

add_library(molequeue_static STATIC ${mq_srcs} ${ui_srcs})
qt5_use_modules(molequeue_static ${qt_components})
set_target_properties(molequeue_static PROPERTIES AUTOMOC TRUE)
target_link_libraries(molequeue_static MoleQueueServerCore)

if(MoleQueue_USE_EZHPC_UIT)
  target_link_libraries(molequeue_static KDSoap::kdsoap)
endif()

if(MoleQueue_BUILD_CLIENT)
  target_link_libraries(molequeue_static MoleQueueClient)
endif()

set(sources main.cpp)
# Handle Mac OS X specific icons etc.
if(APPLE)
  list(APPEND sources icons/molequeue.icns)
  set(MACOSX_BUNDLE_ICON_FILE molequeue.icns)
  set(MACOSX_BUNDLE_BUNDLE_VERSION "${MoleQueue_VERSION}")
  set_source_files_properties(icons/molequeue.icns PROPERTIES
    MACOSX_PACKAGE_LOCATION Resources)
elseif(WIN32)
  list(APPEND sources icons/molequeue.rc)
endif()

add_executable(molequeue WIN32 MACOSX_BUNDLE ${sources} ${rcc_srcs})
qt5_use_modules(molequeue ${qt_components})
target_link_libraries(molequeue molequeue_static)
if(WIN32)
  target_link_libraries(molequeue Qt5::WinMain)
endif()
if(APPLE)
  set_target_properties(molequeue PROPERTIES
    OUTPUT_NAME ${MACOSX_BUNDLE_NAME})
endif()

install(TARGETS molequeue
  RUNTIME DESTINATION ${INSTALL_RUNTIME_DIR}
  BUNDLE DESTINATION .
  )

include_directories("${CMAKE_CURRENT_BINARY_DIR}/client")

# Config file for build options.
configure_file(molequeueconfig.h.in molequeueconfig.h)

# Only run tests if building both client and app:
if(ENABLE_TESTING AND MoleQueue_BUILD_CLIENT AND MoleQueue_BUILD_APPLICATION)
  add_subdirectory(testing)
endif()

=== molequeue/client/CMakeLists.txt ===
find_package(Qt5 COMPONENTS Network REQUIRED)

set(sources
  client.cpp
  jobobject.cpp
  jsonrpcclient.cpp
  )

set(headers
  client.h
  jobobject.h
  jsonrpcclient.h
  )

include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_library(MoleQueueClient ${sources})
qt5_use_modules(MoleQueueClient Network)
set_target_properties(MoleQueueClient PROPERTIES AUTOMOC TRUE)
include(GenerateExportHeader)
generate_export_header(MoleQueueClient EXPORT_FILE_NAME molequeueclientexport.h)
list(APPEND headers "${CMAKE_CURRENT_BINARY_DIR}/molequeueclientexport.h")
set_property(TARGET MoleQueueClient APPEND
    PROPERTY COMPILE_FLAGS ${molequeue_export_flags})

install(FILES ${headers}
  DESTINATION "${INSTALL_INCLUDE_DIR}/molequeue/client")
install(TARGETS MoleQueueClient
  EXPORT "MoleQueueTargets"
  RUNTIME DESTINATION ${INSTALL_RUNTIME_DIR}
  LIBRARY DESTINATION ${INSTALL_LIBRARY_DIR}
  ARCHIVE DESTINATION ${INSTALL_ARCHIVE_DIR}
  )

=== molequeue/lastinstall/CMakeLists.txt ===
if((APPLE OR WIN32) AND NOT ${CMAKE_VERSION} VERSION_LESS 2.8.8)
  find_package(Qt5 COMPONENTS Core REQUIRED)
  set(pfx "")
  if(NOT APPLE)
    set(pfx "bin/")
  endif()

  set(sfx "")
  if(APPLE)
    set(sfx ".app")
  elseif(WIN32)
    set(sfx ".exe")
  endif()

  get_target_property(output_name molequeue OUTPUT_NAME)
  if(output_name)
    set(exe "${pfx}${output_name}${sfx}")
  else()
    set(exe "${pfx}molequeue${sfx}")
  endif()

  get_property(MoleQueue_PLUGINS GLOBAL PROPERTY MoleQueue_PLUGINS)
  set(plugins "")
  foreach(plugin ${MoleQueue_PLUGINS})
    # get_property(location TARGET ${plugin} PROPERTY LOCATION)
    list(APPEND plugins ${plugin})
  endforeach()

  set(dirs "${CMAKE_INSTALL_PREFIX}/${INSTALL_LIBRARY_DIR}")
  if(CMAKE_PREFIX_PATH)
    foreach(dir ${CMAKE_PREFIX_PATH})
      list(APPEND dirs "${dir}/bin" "${dir}/lib")
    endforeach()
  endif()

  find_package(Qt5 COMPONENTS Widgets Network REQUIRED)

  include(InstallRequiredSystemLibraries)
  include(DeployQt5)
  install_qt5_executable(${exe} "${plugins}" "" "${dirs}" "lib/molequeue/plugins")
endif()

=== molequeue/plugins/CMakeLists.txt ===
find_package(Qt5 COMPONENTS Network REQUIRED)

if (MSVC)
  # Do not generate manifests for the plugins - caused issues loading plugins
  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /MANIFEST:NO")
endif()

set_property(GLOBAL PROPERTY MoleQueue_PLUGINS)

add_subdirectory(localsocketserver)

if(USE_ZERO_MQ)
  add_subdirectory(zeromqserver)
endif()

=== molequeue/servercore/CMakeLists.txt ===
find_package(Qt5 COMPONENTS Network REQUIRED)

include(GenerateExportHeader)

add_library(MoleQueueServerCore
  connection.h
  connectionlistener.h
  jsonrpc.cpp
  localsocketconnection.cpp
  localsocketconnectionlistener.cpp
  message.cpp
  messageidmanager_p.cpp
)

qt5_use_modules(MoleQueueServerCore Network)
set_target_properties(MoleQueueServerCore PROPERTIES AUTOMOC TRUE)
#target_link_libraries(MoleQueueServerCore)

set(hdrs
  connection.h
  connectionlistener.h
  connectionlistenerfactory.h
  jsonrpc.h
  localsocketconnection.h
  localsocketconnectionlistener.h
  message.h
  servercoreglobal.h
)

generate_export_header(MoleQueueServerCore
  EXPORT_FILE_NAME molequeueservercoreexport.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})
set_property(TARGET MoleQueueServerCore APPEND
  PROPERTY COMPILE_FLAGS ${molequeue_export_flags})

list(APPEND hdrs
  "${CMAKE_CURRENT_BINARY_DIR}/molequeueservercoreexport.h")

install(FILES ${hdrs} DESTINATION "${INSTALL_INCLUDE_DIR}/molequeue/servercore")
install(TARGETS MoleQueueServerCore
  EXPORT "MoleQueueTargets"
  RUNTIME DESTINATION ${INSTALL_RUNTIME_DIR}
  LIBRARY DESTINATION ${INSTALL_LIBRARY_DIR}
  ARCHIVE DESTINATION ${INSTALL_ARCHIVE_DIR})

=== molequeue/zeromq/CMakeLists.txt ===
find_package(Qt5 COMPONENTS Network REQUIRED)
find_package(ZeroMQ REQUIRED)
include_directories(SYSTEM ${ZeroMQ_INCLUDE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})

include(GenerateExportHeader)

add_definitions(-DUSE_ZERO_MQ)

set(sources
  zeromqconnection.cpp
  zeromqconnectionlistener.cpp
)

add_library(MoleQueueZeroMq ${sources})
qt5_use_modules(MoleQueueZeroMq Network)
set_target_properties(MoleQueueZeroMq PROPERTIES AUTOMOC TRUE)
target_link_libraries(MoleQueueZeroMq MoleQueueServerCore ${ZeroMQ_LIBRARIES})

generate_export_header(MoleQueueZeroMq
  EXPORT_FILE_NAME molequeuezeromqexport.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})
set_property(TARGET MoleQueueZeroMq APPEND
  PROPERTY COMPILE_FLAGS ${molequeue_export_flags})

list(APPEND hdrs
  "${CMAKE_CURRENT_BINARY_DIR}/molequeuezeromqexport.h")

install(FILES ${hdrs} DESTINATION "${INSTALL_INCLUDE_DIR}/molequeue/zeromq")
install(TARGETS MoleQueueZeroMq
  EXPORT "MoleQueueTargets"
  RUNTIME DESTINATION ${INSTALL_RUNTIME_DIR}
  LIBRARY DESTINATION ${INSTALL_LIBRARY_DIR}
  ARCHIVE DESTINATION ${INSTALL_ARCHIVE_DIR})

=== molequeue/app/testing/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/molequeue
  ${CMAKE_BINARY_DIR}/molequeue/client
  ${CMAKE_BINARY_DIR}/molequeue/app/testing)

set(MoleQueue_HAS_ZMQ ${USE_ZERO_MQ})
set(MoleQueue_TESTDATA_DIR
  "${MoleQueue_SOURCE_DIR}/molequeue/app/testing/data/")
set(MoleQueue_TESTSCRIPT_DIR
  "${MoleQueue_SOURCE_DIR}/molequeue/app/testing/scripts/")
set(MoleQueue_TESTEXEC_DIR "${MoleQueue_BINARY_DIR}/bin/")
if(PYTHON_EXECUTABLE)
  set(MoleQueue_PYTHON_EXECUTABLE "${PYTHON_EXECUTABLE}")
endif()
configure_file(molequeuetestconfig.h.in molequeuetestconfig.h)

if(USE_ZERO_MQ)
  add_definitions(-DUSE_ZERO_MQ)
endif()

set(testutils_SRCS
  dummyconnection.cpp
  dummyconnectionlistener.cpp
  dummyqueuemanager.cpp
  dummyqueueremote.cpp
  dummyserver.cpp
  dummysshcommand.cpp
  referencestring.cpp
  testserver.cpp
  xmlutils.cpp
)

add_library(testutils STATIC ${testutils_SRCS})
set_target_properties(testutils PROPERTIES AUTOMOC TRUE)
qt5_use_modules(testutils Test)
target_link_libraries(testutils molequeue_static)

set(MyTests
  filespecification
  jobmanager
  jsonrpc
  message
  pbs
  program
  queue
  queuemanager
  queueremote
  server
  sge
  slurm
  sshcommand
  )

# This test is currently only configured to run on unix
if(NOT WIN32)
  list(APPEND MyTests clientserver)
endif()

if(MoleQueue_USE_EZHPC_UIT)
  list(APPEND MyTests
    authenticatecont
    authenticateresponse
    compositeiodevice
    dirlistinginfo
    filestreamingdata
    jobeventlist
    jobsubmissioninfo
    kerberoscredentials
    uit
    userhostassoclist)
endif()

foreach(test ${MyTests})
  add_executable(${test}test MACOSX_BUNDLE ${test}test.cpp)
  qt5_use_modules(${test}test Test)
  set_target_properties(${test}test PROPERTIES AUTOMOC TRUE)
  target_link_libraries(${test}test testutils)
  add_test(NAME molequeue-${test} COMMAND ${test}test)
endforeach()

add_subdirectory(clienttestsrc)

=== molequeue/plugins/localsocketserver/CMakeLists.txt ===
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY
  ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/../lib/molequeue/plugins)

add_library(LocalSocketServer MODULE localsocketconnectionlistenerfactory.cpp)
qt5_use_modules(LocalSocketServer Network)
set_target_properties(LocalSocketServer PROPERTIES AUTOMOC TRUE PREFIX "")
target_link_libraries(LocalSocketServer MoleQueueServerCore)

set_property(GLOBAL APPEND PROPERTY MoleQueue_PLUGINS LocalSocketServer)

install(TARGETS LocalSocketServer
  DESTINATION ${INSTALL_LIBRARY_DIR}/molequeue/plugins)

=== molequeue/plugins/zeromqserver/CMakeLists.txt ===
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY
  ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/../lib/molequeue/plugins)

find_package(ZeroMQ REQUIRED)
include_directories(SYSTEM ${ZeroMQ_INCLUDE_DIR})

add_library(ZeroMqServer MODULE zeromqconnectionlistenerfactory.cpp)
set_target_properties(ZeroMqServer PROPERTIES AUTOMOC TRUE PREFIX "")
target_link_libraries(ZeroMqServer MoleQueueZeroMq)

set_property(GLOBAL APPEND PROPERTY MoleQueue_PLUGINS ZeroMqServer)

install(TARGETS ZeroMqServer
  DESTINATION ${INSTALL_LIBRARY_DIR}/molequeue/plugins)

=== debian/changelog ===
molequeue (0.9.0-2) unstable; urgency=medium

  * debian patch cmake4.patch sets minimum cmake version 3.5
    to enable cmake 4. Closes: #1113293
  * Mark libmolequeue-dev as Multi-Arch: same
  * Standards-Version: 4.7.2

 -- Drew Parsons <dparsons@debian.org>  Sat, 27 Sep 2025 19:05:35 +0200

molequeue (0.9.0-1) unstable; urgency=low

  * Initial release.

 -- Michael Banck <mbanck@debian.org>  Sun, 23 May 2021 16:52:02 +0200

=== debian/control ===
Source: molequeue
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Drew Parsons <dparsons@debian.org>,
           Michael Banck <mbanck@debian.org>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               qttools5-dev
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/debichem-team/molequeue
Vcs-Git: https://salsa.debian.org/debichem-team/molequeue.git
Homepage: https://www.openchemistry.org/projects/molequeue/

Package: molequeue
Architecture: any
Section: science
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Desktop integration of high performance computing resources
 MoleQueue is a desktop application for abstracting, managing, and coordinating
 the execution of tasks both locally and on remote computational resources.
 Users can set up local and remote queues that describe where the task will be
 executed. Each queue can have programs, with templates to facilitate the
 execution of the program. Input files can be staged, and output files
 collected using a standard interface. Some highlights:
 .
  * Intuitive interface designed to be useful to whole community
  * Support for local executation and remote schedulers (SGE, PBS, SLURM)
  * System tray resident application managing queue of queues and job lifetime
  * Simple, lightweight JSON-RPC 2.0 based communication over local sockets

Package: libmolequeue-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Desktop integration of high performance computing resources (development files)
 MoleQueue is a desktop application for abstracting, managing, and coordinating
 the execution of tasks both locally and on remote computational resources.
 Users can set up local and remote queues that describe where the task will be
 executed. Each queue can have programs, with templates to facilitate the
 execution of the program. Input files can be staged, and output files
 collected using a standard interface. Some highlights:
 .
  * Intuitive interface designed to be useful to whole community
  * Support for local executation and remote schedulers (SGE, PBS, SLURM)
  * System tray resident application managing queue of queues and job lifetime
  * Simple, lightweight JSON-RPC 2.0 based communication over local sockets
  * Qt 5 client library for simple integration in Qt applications
 .
 This package contains the static library and the header files.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk

export CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS) -fPIC
export CFLAGS   := $(CPPFLAGS) $(shell dpkg-buildflags --get CFLAGS)
export CXXFLAGS := $(CPPFLAGS) $(shell dpkg-buildflags --get CXXFLAGS)
export LDFLAGS  := -fPIC $(shell dpkg-buildflags --get LDFLAGS) -Wl,-z,defs -Wl,--as-needed

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

CMAKE_OPTS=-DBUILD_SHARED_LIBS=OFF \
           -DCMAKE_SKIP_RPATH=ON

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure-arch:
	dh_auto_configure -- $(CMAKE_OPTS)

#override_dh_auto_configure-indep:
#	dh_auto_configure -- -DBUILD_DOCUMENTATION=ON $(CMAKE_OPTS)
#
#override_dh_auto_build-indep:
#	cd obj-$(DEB_HOST_GNU_TYPE); make documentation
#
#override_dh_auto_install-arch:
#	dh_auto_install -a
#	cp -r obj-$(DEB_HOST_GNU_TYPE)/bin debian/tmp/usr
#
#override_dh_auto_install-indep:
#	if [ ! -d debian/tmp ]; then mkdir -p debian/tmp; fi
#	cp -r obj-$(DEB_HOST_GNU_TYPE)/docs/html debian/tmp

override_dh_missing:
	dh_missing --list-missing

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%molequeue-$1.tar.gz%" \
    https://github.com/OpenChemistry/molequeue/tags \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
